Neuer Build
===========


* release: Wird ein *Tag* vergeben (egal welcher Branch) der mit 'v' beginnt, erzeugt das automatisch einen Build - https://w3.math.uzh.ch/qfq/release.
* snapshot: Jeder Commit (egal welcher Branch) erzeugt einen Snapshot - https://w3.math.uzh.ch/qfq/snapshot.
* nightly: Nach einem Commit auf Branch 'master' tagsueber, wird um 23:55 ein 'nightly' Build erstellt - https://w3.math.uzh.ch/qfq/nightly.

Neue Versionsnummer
===================

1) Fuer jede neue Version ein Ticket erstellen. Template: #6994

2) * Merge 'open Branches' to **Develop**.
   * Merge 'Develop' to **Master**.
   * Checkout **Master**.

3) Die aktuellen Commits anschauen und wichtige Topics uebernehmen (git log > ~/qfq.log, alles bis zum letzten TAG anschauen):

   * **All commits since last tag**:
     git log $(git describe --tags --abbrev=0)..HEAD --oneline | cut -c9- > /tmp/out; pluma  /tmp/out

       * All commits since tag 'v20.11.0'
         git log v20.11.0..HEAD --oneline

       * complicated:
         git log | grep -v -e '^commit ' -e  '^Author: ' -e '^Date: ' -e '^Merge: ' > /tmp/out; pluma  /tmp/out

   * **Anpassen**: qfq/extension/Documentation/Release.rst

   * Release.rst **verteilen**:  make copyReleaseNotes

   * Manuell:

       * Den Inhalt von Release.rst kopieren nach qfq/extension/RELEASE.txt.
       * Den Inhalt von Release.rst kopieren nach CHANGELOG.md.

   * Tickets

       * Alle offenen Tickets im aktuellen Milestones verschieben auf den naechsten Milestone.
       * Abgeschlossene Tickets schliessen.

4) In folgenden Files anpassen:

   **Achtung**: die Release Minor darf KEINE fuehrenden Nullen enthalten!!! Ansonsten funktioniert die Verteilung vie
   TER nicht.

   **Auto**: ./setVersion.sh 21.12.0

   Manuell:
    * extension/Documentation/_make/conf.py: release, version-
    * Documentation/Settings.cfg: version
    * extension/ext_emconf.php: version

5) **Update Version & Commit**

    * **Commit & Push** to master branch:

   New version 21.12.0

6) **New Tag**:

   git tag v21.12.0

7) **Merge 'master' into 'develop'**

8) Tickets:
   * Schliessen und der QFQ Version zuweisen.
   * Aktuellen Milestone schliessen

9) QFQ Doc aktualisieren

   Erfolgt implicit durch Commit in Branch Master & Develop.

10) Extension hochladen

   TER: https://extensions.typo3.org/ > Log in > My Extensions.


Upload new version to TER
=========================

* https://extensions.typo3.org/ > Log in > My Extensions.
* Rename the ZIP file to be TER compatible: e.g. qfq_18.6.0.zip.
* Upload - that's all.
